from .recipe import Beaker


class ConditionalFilter:
    def __init__(self, condition: callable, true_path: Beaker, false_path: Beaker):
        self.condition = condition
        self.true_path = true_path
        self.false_path = false_path

    def __repr__(self):
        return (
            f"ConditionalFilter({self.condition}, {self.true_path}, {self.false_path})"
        )

    def __call__(self, item):
        if self.condition(item):
            self.true_path.add_item(item)
        else:
            self.false_path.add_item(item)
